# Class CLN2SectionReadableImageArray

java.lang.Object
com.io7m.calino.vanilla.internal.CLN2SectionReadableAbstract
com.io7m.calino.vanilla.internal.CLN2SectionReadableImageArray

All Implemented Interfaces:
  `CLNSectionReadableImageArrayType, CLNSectionReadableStandardType, CLNSectionReadableType, AutoCloseable`

public final class CLN2SectionReadableImageArray extends CLN2SectionReadableAbstract implements CLNSectionReadableImageArrayType
A readable array image section.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SeekableByteChannel`
  `mipMapDataRaw(CLNImageArrayDescription description)`
  Obtain a readable channel that returns potentially compressed data.
  `ReadableByteChannel`
  `mipMapDataWithoutSupercompression(CLNImageArrayDescription description)`
  Obtain a readable channel that returns decompressed data (that is, data with any supercompression removed).
  `List<CLNImageArrayDescription>`
  `mipMapDescriptions()`

  ### Methods inherited from class CLN2SectionReadableAbstract

  `close, errorLimitExceeded, reader, request, section, sectionDataChannel, sectionDataReader`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface CLNSectionReadableType

  `close, section, sectionDataChannel`

- ## Method Details

  - ### mipMapDescriptions

    public List<CLNImageArrayDescription> mipMapDescriptions() throws CLNException
    Specified by:
      `mipMapDescriptions` in interface `CLNSectionReadableImageArrayType`
    Returns:
      The set of declared mipmaps
    Throws:
      `CLNException` - On errors

  - ### mipMapDataWithoutSupercompression

    public ReadableByteChannel mipMapDataWithoutSupercompression(CLNImageArrayDescription description) throws CLNException
    Description copied from interface: `CLNSectionReadableImageArrayType`
    Obtain a readable channel that returns decompressed data (that is, data with any supercompression removed).
    Specified by:
      `mipMapDataWithoutSupercompression` in interface `CLNSectionReadableImageArrayType`
    Parameters:
      `description` - The image description
    Returns:
      A readable channel
    Throws:
      `CLNException` - On I/O errors

  - ### mipMapDataRaw

    public SeekableByteChannel mipMapDataRaw(CLNImageArrayDescription description) throws CLNException
    Description copied from interface: `CLNSectionReadableImageArrayType`
    Obtain a readable channel that returns potentially compressed data. The bytes returned by the channel are not interpreted in any form, and are exactly as they appeared in the underlying file.
    Specified by:
      `mipMapDataRaw` in interface `CLNSectionReadableImageArrayType`
    Parameters:
      `description` - The image description
    Returns:
      A readable channel
    Throws:
      `CLNException` - On I/O errors